MODULE initsh

IMPLICIT none
 
 INTEGER:: imodel,ithom,irayl,ipart,ichemc,irotat,ielnd
 INTEGER:: ionu,iore,iot,nphase
 INTEGER:: lunt1,lunt2,lunt3
 INTEGER:: nbodf1,nbodf2,nbodf3,nbod1,nbod2,nbod3
 INTEGER:: istar,icomp,ispot,idisc,ism,ijet,ishell
 INTEGER:: irrst,irrcp,itdc
 

 REAL(KIND=8):: alam1,alamn,alams,cutoff
 REAL(KIND=8):: eps,offset
 REAL(KIND=8):: phase1,phasen,dinc,dd
 REAL(KIND=8):: rmodfx,rmodfy,rmodfz,gainfx,gainfy,gainfz
 REAL(KIND=8):: xunt1,xunt2,xunt3,yunt1,yunt2,yunt3
 REAL(KIND=8):: rmodx,rmody,rmodz,gainx,gainy,gainz
 REAL(KIND=8):: rstar,tstar,emstar
 REAL(KIND=8):: xstar,ystar,zstar,vrotst
 REAL(KIND=8):: vxst,vyst,vzst
 REAL(KIND=8):: dlst,dlst2,dgst,ffst,albst,htst,htsta
 REAL(KIND=8):: vrxcp,vrycp,vrzcp,vrotcp,rcp
 REAL(KIND=8):: xcp,ycp,zcp,vxcp,vycp,vzcp
 REAL(KIND=8):: tempcp,dlcp,dlcp2,dgcp,ffcp,qq,albcp,htcp,htcpa
 REAL(KIND=8):: vrxsp,vrysp,vrzsp,vrotsp,rsp
 REAL(KIND=8):: xsp,ysp,zsp,vxsp,vysp,vzsp
 REAL(KIND=8):: tempsp,denssp,anesp,vtrbsp
 REAL(KIND=8):: adisc,rindc,routdc
 REAL(KIND=8):: xdisc,ydisc,zdisc
 REAL(KIND=8):: vxdc,vydc,vzdc
 REAL(KIND=8):: tempdc,densdc,anedc,vtrbdc,edendc
 REAL(KIND=8):: v1sm,v2sm,rsm
 REAL(KIND=8):: x1sm,y1sm,z1sm,x2sm,y2sm,z2sm
 REAL(KIND=8):: tempsm,denssm,anesm,vtrbsm
 REAL(KIND=8):: xjet,yjet,zjet,ajet,rinjt,routjt,vjt
 REAL(KIND=8):: tempjt,densjt,anejt,vtrbjt
 REAL(KIND=8):: rinsh,routsh,vsh
 REAL(KIND=8):: evelsh,rcsh
 REAL(KIND=8):: tempsh,denssh,anesh,vtrbsh
 REAL(KIND=8):: temp0,dens0,ane0,v0


 CONTAINS 
 
 SUBROUTINE shell_init

 IMPLICIT NONE
  
  imodel=1
  ithom=1
  irayl=1
  ipart=1
  ichemc=1
  irotat=1
  ielnd=1
  ionu=1
  iore=61
  iot=41
  nphase=0
  lunt1=1
  lunt2=0
  lunt3=0
  nbodf1=100
  nbodf2=100
  nbodf3=100
  nbod1=100
  nbod2=100
  nbod3=100
  istar=1
  icomp=0
  ispot=0
  idisc=1
  ism=0
  ijet=0
  ishell=0
 
  alam1=6530.8d0
  alamn=6600.8d0
  alams=0.2d0
  cutoff=50.d0
  eps=1.d0
  offset=0.2d0
  phase1=0.d0
  phasen=360.d0
  dinc=14.6d0
  dd=467.d0 
  rmodfx=55.d0
  rmodfy=55.d0
  rmodfz=55.d0
  gainfx=1.0d0
  gainfy=1.0d0
  gainfz=1.0d0
  xunt1=1.d0
  xunt2=1.d0
  xunt3=1.d0
  yunt1=1.d0
  yunt2=1.d0
  yunt3=1.d0
  rmodx=55.d0
  rmody=55.d0
  rmodz=55.d0
  gainx=1.0d0
  gainy=1.0d0
  gainz=1.0d0
! --------------- central star -----
  rstar=5.1d0
  tstar=27000.d0
  emstar=11.8d0
  xstar=0.d0
  ystar=0.d0
  zstar=1.d0
  vrotst=320.d0
  vxst=0.d0
  vyst=0.d0
  vzst=0.d0
  dlst=0.5d0
  dlst2=0.d0
  dgst=0.d0
  ffst=1.01d0
  albst=0.3d0
  htst=0.6d0
  htsta=1.d0
  irrst=0
! ----------------- companion -----
  vrxcp=0.d0
  vrycp=0.d0
  vrzcp=1.d0
  vrotcp=43.d0
  rcp=5.87d0
  xcp=22.63d0
  ycp=0.d0
  zcp=0.d0
  vxcp=0.d0
  vycp=134.d0
  vzcp=0.d0
  tempcp=4600.d0
  dlcp=0.8d0
  dlcp2=0.d0
  dgcp=0.08d0
  ffcp=1.d0
  qq=0.2261d0
  albcp=0.d0
  htcp=0.d0
  htcpa=0.d0
  irrcp=0
! ---------------------- spot -----
  vrxsp=0.d0
  vrysp=0.d0
  vrzsp=1.d0
  vrotsp=0.d0
  rsp=3.d0
  xsp=9.d0
  ysp=9.d0
  zsp=0.d0
  vxsp=100.d0
  vysp=0.d0
  vzsp=0.d0
  tempsp=4500.d0
  denssp=3.d-14
  anesp=5.d11
  vtrbsp=0.d0
! ---------------- disc ------
  adisc=25.d0
  rindc=5.d0
  routdc=10.587d0
  xdisc=0.d0
  ydisc=0.d0
  zdisc=1.d0
  vxdc=0.d0
  vydc=0.d0
  vzdc=0.d0
  tempdc=14500.d0
  densdc=1.4d-13
  anedc=2.d10
  vtrbdc=70.d0
  edendc=-3.5d0
  itdc=2
!  ------------------stream -----
  v1sm=250.d0
  v2sm=530.d0
  rsm=3.d0
  x1sm=10.d0
  y1sm=1.5d0
  z1sm=0.d0
  x2sm=0.d0
  y2sm=3.d0
  z2sm=0.d0
  tempsm=8000.d0
  denssm=20.d-15
  anesm=21.d9
  vtrbsm=50.d0
! ---- jet ---
  xjet=1.d0
  yjet=0.d0
  zjet=2.d0
  ajet=9.d0
  rinjt=3.d0
  routjt=10.d0
  vjt=360.d0
  tempjt=10200.d0
  densjt=0.9d-11
  anejt=0.5d13
  vtrbjt=10.d0
! ------------------------ shell ----
  rinsh=6.5d0
  routsh=7.4d0
  vsh=40.d0
  evelsh=0.5d0
  rcsh=4.d0
  tempsh=9500.d0
  denssh=0.14d-11
  anesh=0.57d12
  vtrbsh=10.d0
!  ------------------- background ----
  temp0=4000.d0
  dens0=0.d0
  ane0=1.d8
  v0=0.d0
  
 END SUBROUTINE shell_init

END MODULE initsh
!-----------------------------------------------------------------------
!  Definition of the input quantities:                             
!  alam1, alamn, alams -start,end and step of wavelength in [A]    
!  cutoff - distance from the sp. line center up to which its
!          line opacity is considered in [A]. Assuming 
!          broadening by the velocity field dominates:
!          cutoff>maximal radial velocity/c*lambda 
!  imodel=1  calculate your own input shell model                  
!  imodel=2  read input shell model from `shellspec.mod'.          
!          You can ignore most of input below defining geometry,   
!          the velocity field and state quantities of objects but
!          you must still input the data for the scattering:           
!            rstar,tstar,vxst,vyst,vzst                              
!          for the coordinate rotation:                        
!            temp0,ane0,xcp,ycp,zcp 
!          and for the limb darkening:
!            istar,rstar,tstar,dlst,dlst2,
!            icomp,rcp,tempcp,dlcp,dlcp2,xcp,qq
!          and switches: lunt1, lunt2, lunt3, ithom, irayl, eps
!  ithom=0 Thomson scattering is off
!  ithom=1 Thomson scattering is on           
!  irayl=0 Rayleigh scattering on neutral hydrogen is off.
!          If Lyman lines are treated explicitely in the linelist
!          set irayl=0 not to count the contribution twice
!  irayl=1 Rayleigh scattering on neutral hydrogen is on
!  ipart  -option of partition functions 
!          [1-built in Dworetsky & Smalley, 2-Irwin]
!          (only ipart=1 is implemented so far)
!  ichemc -option of abundances, if ielnd=1 then ichemc=1                                     
!          [0-default solar, 1-read from file `abundances']       
!  irotat -option of interpolation from the body frozen grid
!          to the line of sight grid during the coord. rotation
!          0=linear interpolation, good for continuous fields,
!            otherwise the result may depend on discontinuities
!            or background (temp0,ane0,...)
!          1=nearest neighbour approximation, may be less smooth
!            but handles discontinuities
!  eps -artificial number <0.,1.> for test purpose which splits    
!          the line opacity (emissivity) into the true             
!          absorbtion (eps->1.) and coherent scattering (eps->0.). 
!          In LTE eps=1. ( S=eps*B+(1-eps)*J )  
!          If ithom=irayl=0 set also eps=1. for consistency                   
!  ielnd=1 electron number densities provided in the input model
!          are ignored and code calculates el.num.dens. 
!          assuming LTE, from known temperature, density and 
!          chemical composition. File 'abundances' is read and must
!          contain 3.column which specifies which elements are
!          considered in Ne calculations, this sets ichemc=1
!  ielnd=0 electron number densities are known apriori and are
!          specified in the input model
!  ionu, ior, iot -sequential indexes of frequency, x, and y point 
!          for which you want a more detailed output along the line
!          of sight (specified by x,y) 
!  offset -vertical shift applied to the normalized spectra output
!          to plot many spectra from different rotation phases        
!  phase1, phasen - start, end of the phase interval you want 
!          to cover [deg] (e.g. if xcp>0,ycp=zcp=0, dinc=90 then
!          phase1=-90 will start from the primary eclipse)
!  nphase -number of rotations (different view points) within 
!          the interval above
!          if nphase=0 then phase1 and phasen are ignored, and it
!          reads one column from the file `phases' with phases. 
!          These are values <0,1> and count from the x axis 
!          so that phase=0.0 or 1.0 is primary eclipse 
!          if xcp>0,ycp=zcp=0, dinc=90
!  dinc   -angle between rotation axis of the model and the line
!          of sight [deg], dinc=90.0 is edge on.
!  dd   -distance to the shell from the Earth in [pc]
!----------------intrinsic spectra specifications:
!  lunt1=0 all objects with density from <dcut1,dcut2> interval are 
!          nontransparent blackbodies with the same temperatures as
!          in the case of transparency. 
!  lunt1>0 all objects with density within <dcut1,dcut2> are 
!          nontransparent and have an intrinsic intensity spectrum.
!          The spectrum is read from file `starspec1'.
!  lunt1=1 the x,y column input required with wavelength [A] and
!          H_lambda flux [erg/cm^2/s/A] (as an output of SYNSPEC)
!  lunt1=2 the x,y column input required with wavelength [A] and
!          I_nu intensity [erg/cm^2/s/Hz/sterad] 
!  lunt1=3 the 4 column input required with idummy,frequency [Hz],
!          dummy, F_nu flux [erg/cm^2/s/Hz]
!          (output of coolTlusty, unit 21, first 2 rows are dummy) 
!  xunt1  -multiplication factor applied to starspec1 x-column
!          if it is not in the correct-required units
!          (otherwise set it =1.)
!  yunt1  -multiplication factor applied to starspec1 y-column
!          if it is not in the correct-required units
!          (otherwise set it =1.)
!  lunt2,xunt2,yunt2 -the same meaning as above except that these
!          deal with density interval <dcut2,dcut3> and
!          the spectrum is read from file `starspec2'. 
!  lunt3,xunt3,yunt3 -the same meaning as above except that these
!          deal with density interval <dcut3,dcutn> and
!          the spectrum is read from file `starspec3'.          
!-----------definitions of grids:
!  nbodf1, nbodf2, nbodf3 -number of grid points in x, y, z (>=1)
!          direction in body frozen coordinates of the model.
!          It will be flipped arround 0 and expanded to 2*nbodf+1 
!          (it is overridden by the values from `shellspec.mod' 
!          if imodel=2)            
!  rmodfx, rmodfy, rmodfz - xyz half-width of the grid box of 
!          the body frozen frame (if imodel=1)
!  gainfx, gainfy, gainfz -grid step multiplication factors
!          of the body frozen grid to allow for logarithmic grid 
!          [gainfx=(x_{i+1}-x_{i})/(x_{i}-x_{i-1})]
!          e.g. gainfx=1. for equidistant step
!  nbod1, nbod2, nbod3 -number of grid points in x, y, z (>=1)  
!          in the line of sight observer's frame. 
!          It will be reset to 2*nbod+1 
!  rmodx, rmody, rmodz - xyz half-width of the grid box of 
!          observer's line of sight frame
!  gainx, gainy, gainz -grid step multiplication factors
!          of the line of sight grid grid 
!          [gainx=(x_{i+1}-x_{i})/(x_{i}-x_{i-1})]
!          e.g. gainx=1. for equidistant step
!-----------------object definitions:
!  istar,icomp,ispot,idisc,ism,ijet,ishell - see below
!-------primary star----------
!  istar=0 accompanied by rstar=0 will switch off the primary
!  istar=1 central object is a nontransparent uniformly rotating
!    sphere. Its density is set to <dcut1,dcut2>. It can be either 
!    black body with T=tstar if lunt1=0 or has its intrinsic 
!    intensity spectrum if lunt1>0. In case of scattering or 
!    reflection of its light by other objects its rotation is 
!    ignored.
!    Code ignores: dgst,ffst,qq                 
!  istar=2 central object is a detached component of a binary.       
!    It has a Roche shape defined by ffst<=1, synchronous rotation,
!    is nonstrasparent with density within <dcut1,dcut2>.  
!    It can be either black body with T=tstar if lunt1=0 or 
!    has its intrinsic intensity spectrum if lunt1>0. 
!    You must also set: xcp>0,qq>0
!    Code also calculates/ignores: xstar,ystar,zstar,vrotst,rstar
!  istar=3 central object is a figure 8 contact system. It has
!    a Roche shape defined by 1<ffst<=2, synchronous rotation,
!    is nonstrasparent with density within <dcut1,dcut2>.  
!    It can be either black body with T=tstar if lunt1=0 or 
!    has its intrinsic intensity spectrum if lunt1>0. 
!    You must also set: xcp>0,qq>0
!    Code also calculates/ignores: 
!      xstar,ystar,zstar,vrotst,rstar,icomp
!  if istar>1 or icomp>1 then code calculates from emstar,xcp,qq:
!     ycp,zcp,vxst,vyst,vzst,vxcp,vycp,vzcp
!  rstar -radius of the central star in [R_sol] 
!     if istar>1 (Roche Geometry) this value will be used for
!     scattering in the circumstellar matter and irradiation effect 
!     on the companion which use spherical approximation
!  tstar -effective temperature of the central star in [K]
!	   without gravity darkening and irradiation. This value will 
!     be used for scattering in the circumstellar matter (in case 
!     of black body) and irradiation effect on the companion
!     if istar=2 it is the temperature at the rotation pole 
!     if istar=3 it is the temperature at the rotation pole of
!     the more massive star
!  emstar -mass of the central star in [M_sol]
!  xstar,ystar,zstar -define unit aiming vector of the rotational        
!          axis of the central star         
!  vrotst -equatorial rotation velocity of the central star [km/s]
!  vxst, vyst, vzst -net velocity components                 
!          of the center of mass of the central star [km/s]
!  dlst -limb darkening coefficient of the central star
!  dlst2 -second limb darkening coefficient 
!       I=1-dlst*(1-mu)-dlst2*(1-mu)**2
!  dgst -gravity darkening coefficient (beta) of the central star
!		(0.25 for radiative, 0.08 for convective atmospheres)
!          It is dummy if istar=1.
!  ffst<=1 -Roche lobe fill-in factor of the primary. Its is
!    the distance of the inner substellar point of the primary
!    (between the stars) from the center of the primary relative
!    to the distance to L1, the Roche lobe is reproduced if ff=1
!  1<ffst<=2 -Roche lobe fill-out factor of the contact system
!          ffst=(C1-C)/(C1-C2)+1
!          It is dummy if istar=1.
!  irrst=0 -irradiation and reflection effect is off
!      (albst,htst,htsta have no meaning in this case)
!  irrst=1 -irradiation of the object from the companion is on.
!      Irradiation (heating) applies only if istar=1,2.
!      Reflection of the sp. of companion applies if istar=1,2
!      (rcp,tempcp>0 ... are presumed).
!  albst  -Bond albedo <0,1>, if albst<0 then a monochomatic albedo
!	    is red from file=albedo1 and albst=-albst
!  htst   -heat redistribution parameter in case of irradiation, 
!      fraction of the heat absorbed on the day side which is 
!      redistributed over the day-night sides, <0,1>, 
!      0-nothing is redistributed and nothing goes to the night, 
!      1-all the energy (which is not reflected) impinging on 
!      the planet is evenly distributed over the day-night sides.
!      It is analoguous to the so called Pn parameter of A.Burrows
!      (a fraction of the irradiating energy impinging on 
!      the day side which is transfered to and irradiated from 
!      the night side), Pn=(1-albst)*htst/2
!  htsta  -degree of the inhomegenity of the heat transport, <0,1>.
!      1-homegeneous, 0-cosine dependence
!      T**4=T0**4(htsta+4(1-htsta)/pi*cos_latitude)
!  temp*,dens*,ane* - state quantities in various objects   
!          temperature, density, electron number density [K,CGS]
!  vtrb* - microturbulent velocity in various objects [km/s],
!          it does not apply to nontransparent objects
!-------companion or secondary star
!  icomp=0 secondary off
!  icomp=1 secondary on, it is a uniformly rotating nontransparent
!          sphere. It may be a blackbody with T=tempcp if lunt2=0
!          or has its own spectrum if lunt2>0. Its density is set 
!          to <dcut2,dcut3>. Code ignores: dgcp,ffcp,qq
!  icomp=2 secondary is a detached component of a binary.
!    It has a Roche shape defined by ffcp<=1, synchronous rotation,
!    is nonstrasparent with density within <dcut2,dcut3>.  
!    It can be either black body with T=tempcp if lunt2=0 or 
!    has its intrinsic intensity spectrum if lunt2>0. 
!    You must set: xcp>0,qq>0,emstar>0
!    Code also calculates/ignores: vrxcp,vrycp,vrzcp,vrotcp,rcp
!  vrxcp, vrycp, vrzcp -define unit aiming vector of the rotational      
!    axis of the secondary star (companion)
!  vrotcp -equatorial rotation velocity of the companion [km/s]
!  rcp  -radius of the spherical companion [R_sol],
!    if icomp=2 this input is used only for the scattering 
!	  and irradiation from the object otherwise it is superfluous 
!  xcp,ycp,zcp -location of the center (of mass) of 
!          the companion [R_sol]
!  vxcp,vycp,vzcp -components of the velocity vector of the center 
!          (of mass) of the companion [km/s]
!	tempcp -see primary star above, this value is used for 
!    the scattering and irradiation from it
!  dlcp -limb darkening coefficient of the secondary star
!  dlcp2 -second limb darkening coefficient (the same as dlst2)
!  dgcp -gravity darkening coefficient (beta) of the secondary
!  ffcp<=1 -Roche lobe filling factor of the secondary is 
!    the distance of the inner substellar point of the secondary
!    from the center of the secondary relative to 1-L1, 
!    the Roche lobe is reproduced if ffcp=1 
!  qq -mass ratio (companion/star), important only for Roche geom.
!      if istar>1 or icomp>1
!  irrcp=0 -irradiation and reflection effect is off
!      (albcp,htcp,htcpa have no meaning in this case)
!  irrcp=1 -irradiation of the secondary from the primary is on.
!      Irradiation (heating) applies only if icomp=2.
!      Reflection (of the spectrum of primary) applies if icomp=1,2
!      (istar=1,2 and rstar,tstar>0 are presumed)
!  albcp  -Bond albedo <0,1>, if albcp<0 then a monochomatic albedo
!      is red from file=albedo2 and albcp=-albcp
!  htcp   -heat transport parameter in case of the irradiation. 
!      The same as htst, <0,1>.
!  htcpa  -degree of the inhomegenity of the heat transport, <0,1>. 
!      1-homegeneous, 0-cosine dependence, the same as htsta.
!-------spot or third star
!  ispot=0 spot is off
!  ispot=1 spot is on, it is a uniformly rotating sphere
!  vrxsp, vrysp, vrzsp -define unit aiming vector of the rotational      
!          axis of the spot
!  vrotsp -equatorial rotation velocity of the spot [km/s]
!  rsp  -radius of the spherical spot [R_sol]
!  xsp,ysp,zsp -location of the center of the spot [R_sol]
!  vxsp,vysp,vzsp -components of the velocity vector of the center 
!          of the spot [km/s]
!-------accretion disk
!  idisc=0 switch off the disc		
!  idisc=1 disc has the shape of a rotating wedge
!          limited by inner and outer radii (spherical surfaces)
!  idisc=2 disc has the shape of a slab
!          limited by inner and outer radii (spherical surfaces)
!  idisc=3 disc has the shape of a rotating ellipsiod
!          limited by inner spherical and outer ellipsoidal surface
!  adisc -angular halfwidth of the disc wedge [deg] 
!         (if idisc=1)
!        -half of the thickness of the disc slab [R_sol] 
!         (if idisc=2)
!        -semiaxis of the ellipsiod along the rotational axis 
!         [R_sol] (if idisc=3)	
!  rindc -inner radius of the disc [R_sol]
!  routdc -outer radius of the disc [R_sol] or
!         -semiaxix of the ellipsoid perpendicular to the rotation 
!          axis, if idisc=3, [R_sol]
!  xdisc,ydisc,zdisc -components of the unit aiming vector of 
!          the rotational axis of the Keplerian disc around emstar
!  vxdc, vydc, vzdc -net velocity components                 
!          of the center of the disc [km/s]
!  edendc -density dependence exponent 
!          (dens, ane of the disc are a function of r)
!          Rho(r) ~ Ne(r) ~ densdc*(r/rindc)**edendc	                        
!  itdc=1  disc temperature is constant (=tempdc)
!  itdc=2  disc temperature is a function of r
!          T(r)=tempdc*(Rstar/r)**0.75*(1-(Rstar/r)**0.5)**0.25       
!-------stream
!  ism=0/1  -stream off/on
!  v1sm   -stream velocity at the beginnig of stream [km/s]
!  v2sm   -stream velocity at the end of stream [km/s]
!          velocity is directed from beginning to end 
!  denssm - is density at the beginning and scales along the stream
!          to satisfy the continuity equation: v1sm*denssm=const.
!  rsm    -radius of the stream [R_sol]
!  x1sm,y1sm,z1sm -position of the beginning of the stream [R_sol]
!  x2sm,y2sm,z2sm -position of the end of the stream [R_sol]
!-------jet
!  ijet=0   switch off the jet
!  ijet=1  jet has only one -primary cone	
!  ijet=2  jet has two cones: primary cone and opposite one
!  xjet,yjet,zjet -components of the unit aiming vector 
!          of the primary jet cone
!  ajet -angle halfwidth of the jet cones [deg]
!  rinjt, routjt -radius boundaries of the jet cones [R_sol]
!  vjt  -radial (expanding) velocity of the jet [km/s]
!-------shell
!  ishell=0   switch off the shell
!  ishell=1   velocity, dens, temp, ane are constant
!  ishell=2   radial velocity is v(r)=vsh*(r/rinsh)**evelsh
!      Ne(r)~Rho(r)=denssh*(rinsh/r)**2*vsh/v(r)), temp=const.
!  ishell=3   radial velocity is v(r)=vsh*(1-rcsh/r)**evelsh
!      Ne(r)~Rho(r)=denssh*(rinsh/r)**2*v(rinsh)/v(r)),temp=const.
!  rinsh, routsh -inner, outer radius of the shell in [R_sol]     
!  vsh -velocity of the uniformly expanding shell [km/s]           
!  evelsh -exponent of velocity dependence
!  rcsh - core radius of the star in shell [R_sol]
!-------background
!  v0 -constant uniformly expanding velocity of background [km/s]
!-----------------------------------------------------------------------                                                                       
!  If the objects happen to overlap, priority is as follows:         
!          star,companion,spot,disc,stream,jet,shell,background. 
!  temp and ane are assumed to have reasonable values all along 
!  the beam. An empty space can be defined as dens<denvac.         
!  Four types of nontransparent objects can be defined as:         
!  dcut1<dens<dcut2 -central star,                                 
!  dcut2<dens<dcut3 -secondary star(=companion), 
!  dcut3<dens<dcutn -3.body (it can be anything)
!  dcutn<dens -any opaque dark matter.                              
!  These objects are allowed to make eclipses along the line of     
!  sight but cast no shadows into other directions (i.e. are       
!  transparent when considering scattered light from               
!  the central star).                                               
!  Note that lunt1, lunt2, lunt3 are in fact associated with 
!  density intervals (<dcut1,dcut2>, <dcut2,dcut3>, <dcut3,dcutn>) 
!  rather then with objects (star,companion,...) and thus can be 
!  used to ascribe the spectrum to any nontransparent object 
!  setting its density within a particular density interval.
!  However, limb darkening is applied to star and companion only
!  and it must be switched off (dlst=dlcp=0.) if you want to use 
!  these density intervals for other objects (without limb dark.).
!  Roche geometry assumes synchronous rotation around z axis with 
!  star in the center and companion at xcp>0,ycp=zcp=0 revolving 
!  towards (0,1,0).
!  Input variables which are supposed to be components of a unit 
!  vector do not need to be normalized.
 
