MODULE params 
 IMPLICIT NONE

 INTEGER, PARAMETER:: melmln=2,melmns=92,mlayer=200,mlines=1000
 INTEGER, PARAMETER:: msynth=10000,mbroad=10000,mtitle=80,mdipso=100000
 INTEGER, PARAMETER:: mfpram=6,mchmax=50,mdskin=2,mdskot=3,mchlin=5
 INTEGER, PARAMETER:: mchlot=6,mchses=10,minstp=1000
 
! 
! melmln         - size of element abreviations
! melmns         - number of elements
! mlayer         - maximum number of model depths
! mlines         - maximum number of lines in line data buffer
! msynth         - size of "synth" arrays
! mbroad         - size of "broad" arrays
! mtitle         - size of character strings for titles and filenames
! mdipso         - size of "dipso" arrays
! mfpram         - maximum number of free parameters for chifit
! mchmax         - 
! mdskin         - file input unit
! mdskot         - file output unit
! mchlin         - default input unit
! mchlot         - default output unit
! mchses         - unit for session log file
! minstp         - maximum number of points in instrumental profile
! 


 REAL(KIND=8), PARAMETER:: alge10 = 2.302585093D0, around = 0.01D0

! alge10         - value of log(10)
! around         - value by which to round-up errors
! minstp         - maximum number of points in instrumental profile

END MODULE params
